﻿using C1.WPF.FlexGrid;
using System;
using System.Collections.Generic;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace C1FlexGrid_APAStyle
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        DataTable dt;
        public MainWindow()
        {
            InitializeComponent();
            dt= new DataTable();
            dt.Columns.Add("Breed", typeof(String));
            dt.Columns.Add("Male", typeof(Int32));
            dt.Columns.Add("Female", typeof(Int32));
            dt.Columns.Add("%", typeof(Double));
            dt.Rows.Add("Dachshund",123,234,17.6);
            dt.Rows.Add("Terrier", 456, 567, 31.1);
            dt.Rows.Add("Siberian Husky", 789, 891, 51.3);
        }
        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            _c1Flex.ItemsSource = dt.DefaultView;
            _c1Flex.GridLinesVisibility = C1.WPF.FlexGrid.GridLinesVisibility.None;
            _c1Flex.HeaderGridLinesBrush = System.Windows.Media.Brushes.White;
            foreach( C1.WPF.FlexGrid.Column col in _c1Flex.Columns)
            {
                col.HeaderBackground = System.Windows.Media.Brushes.White;
                if (col.DataType != typeof(string))
                {
                    col.HeaderHorizontalAlignment = HorizontalAlignment.Center;
                    col.HorizontalAlignment = HorizontalAlignment.Center;
                    if(col.ColumnName == "Male" || col.ColumnName == "Female")
                    col.GroupAggregate = C1.WPF.FlexGrid.Aggregate.Sum;
                }
                else
                {
                    col.HeaderHorizontalAlignment = HorizontalAlignment.Left;
                    col.HorizontalAlignment = HorizontalAlignment.Left;
                    col.GroupAggregate = C1.WPF.FlexGrid.Aggregate.Sum;
                }
                col.HeaderCellStyle.TextDecorations = TextDecorations.Underline;
                col.HeaderCellStyle.FontWeight = FontWeights.Bold;
            }
            _c1Flex.RowHeaders.Columns[0].Visible = false;
            _c1Flex.AutoSizeColumns(0, _c1Flex.Columns.Count - 1,10);
            var gr = new C1.WPF.FlexGrid.GroupRow();
            gr.FontWeight = FontWeights.Bold;
            gr.Background = System.Windows.Media.Brushes.White;
            _c1Flex.ColumnFooters.Rows.Add(gr);
            var sum = Convert.ToInt32(gr["Male"]) + Convert.ToInt32(gr["Female"]);
            gr[0] = String.Format("Totals(N={0})",sum);

        }
        void SaveToPng(FrameworkElement visual, string fileName)
        {
            var encoder = new PngBitmapEncoder();
            SaveUsingEncoder(visual, fileName, encoder);
        }
        void SaveUsingEncoder(FrameworkElement visual, string fileName, BitmapEncoder encoder)
        {
            RenderTargetBitmap bitmap = new RenderTargetBitmap((int)visual.ActualWidth, (int)((int)visual.ActualHeight+20), 96, 96, PixelFormats.Pbgra32);
            bitmap.Render(visual);
            BitmapFrame frame = BitmapFrame.Create(bitmap);
            encoder.Frames.Add(frame);
            using (var stream = File.Create(fileName))
            {
                encoder.Save(stream);
            }
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
           // _c1Flex.AutoSizeColumns(0, _c1Flex.Columns.Count - 1, 0);

            SaveToPng(ANATable, "MyGrid.png");
            FileStream f = new FileStream("MyGrid.png", FileMode.Open);

            Bitmap b = new Bitmap(f, true);

            Clipboard.SetDataObject(b, true);

            Microsoft.Office.Interop.Word.Application app = new Microsoft.Office.Interop.Word.Application();
            object missing = System.Reflection.Missing.Value;
            Microsoft.Office.Interop.Word.Document document = app.Documents.Add(ref missing, ref missing, ref missing, ref missing);
            object filename = "C1FlexGridExport.docx";
            document.SaveAs(ref filename);
           // object file = @"C:\Users\GPCTAdmin\Documents\ScreenDoc.doc";
            //Use Reflection to identify the missing values
            object miss = System.Reflection.Missing.Value;
            object otrue = true;
            object ofalse = false;
            try
            {
                Microsoft.Office.Interop.Word.Document doc = app.Documents.Open(ref filename, ref miss, ref ofalse, ref miss, ref
                          miss, ref miss, ref miss, ref miss, ref miss, ref miss, ref miss, ref otrue);
                object start = 0;
                object end = 0;
                Microsoft.Office.Interop.Word.Range rng = doc.Range(ref start, ref end);
                rng.Paste();
                doc.Save();

               // app.Quit(ref otrue, ref miss, ref miss);
                
                MessageBox.Show("Image saved in a document");
            }
            catch (Exception ex)
            {
                MessageBox.Show("" + ex.Message);
            }
        }
    }
}
